﻿@model LoyaltyPointEngine.Model.Parameter.Notification.ParamSendNotification
@{
    List<SelectListItem> notificationTypeList = (List<SelectListItem>)ViewBag.NotificationTypeList;
    var monthList = (IEnumerable<SelectListItem>)ViewBag.Months;
    var yearList = (IEnumerable<SelectListItem>)ViewBag.Years;
}
<!--=== Page Content ===-->
<div class="row">
    <div class="col-md-12">
        <h5 class="widget-title"><i class="icon-sign-blank"></i>Send Notification</h5>
    </div>
    @if (!string.IsNullOrEmpty(ViewBag.Success))
    {
        <div class="col-md-12">
            <div class="alert alert-success alert-dismissible" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                @ViewBag.Success
            </div>
        </div>
    }
</div>
@using (Html.BeginForm(MVC.NotificationManager.Send(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "form-send-notification" }))
{
    <div class="row">
        <!--=== Validation Example 1 ===-->
        <div class="col-md-12">
            <div class="widget box">
                <div class="widget-header">
                    <h4><i class="icon-reorder"></i>Receipt Header</h4>
                </div>
                <div class="widget-content">
                    @Html.AntiForgeryToken()
                    <div class="error-widget alert alert-danger hide">
                        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                        <i class="fa fa-times-circle"></i>
                        Error occured:
                        <br />
                        <div class="message-error-detail">
                            @Html.ValidationSummary()
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Members <span class="required">*</span></label>
                        <div class="col-md-6">
                            @Html.HiddenFor(x => x.MemberIDs)
                            @Html.TextAreaFor(x => x.MemberNames, new { @class = "form-control multiple-select-member", @readonly = "", @required = "" })
                            @Html.ValidationMessageFor(x => x.MemberIDs)
                        </div>
                        <button id="btn-select-member" type="button" class="col-md-3 btn btn-primary" data-toggle="modal" data-target="#memberModal" data-whatever="lala">Select Member</button>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">To All Member</label>
                        <div class="col-md-3">
                            @Html.CheckBoxFor(x => x.ToAllMembers, new { @class = "" })
                        </div>
                        @Html.DropDownList("Month", monthList, "", new { @class = "select2-select-00 col-md-3" })
                        @Html.DropDownList("Year", yearList, "", new { @class = "select2-select-00 col-md-2" })
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Title <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.Title, new { @class = "form-control", @required = "" })
                            @Html.ValidationMessageFor(x => x.Title)
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Message <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextAreaFor(x => x.Message, new { @class = "form-control", @required = "" })
                            @Html.ValidationMessageFor(x => x.Message)
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Reference Code </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.ReferenceCode, new { @class = "form-control" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Point </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.Point, new { @class = "form-control" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Type <span class="required">*</span></label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.Type, notificationTypeList, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required" })
                            @Html.ValidationMessageFor(x => x.Type)
                        </div>
                    </div>
                    <div id="DivLeftIcon" class="form-group hidden">
                        <label class="col-md-3 control-label">Left Icon </label>
                        <div class="col-md-9">
                            <div class="input-group">
                                @Html.TextBoxFor(x => x.LeftIcon, new { @class = "form-control" })
                                <span class="input-group-btn">
                                    <button id="BtnLeftIcon" class="btn btn-default" type="button">Upload</button>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div id="DivRightIcon" class="form-group hidden">
                        <label class="col-md-3 control-label">Right Icon </label>
                        <div class="col-md-9">
                            <div class="input-group">
                                @Html.TextBoxFor(x => x.RightIcon, new { @class = "form-control" })
                                <span class="input-group-btn">
                                    <button id="BtnRightIcon" class="btn btn-default" type="button">Upload</button>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="form-actions">
                        <input type="submit" value="Submit" class="btn btn-primary pull-right">
                    </div>
                </div>
            </div>
            <!-- /Validation Example 1 -->
        </div>
    </div>
}

<div class="modal fade" id="memberModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" style="width: auto !important" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Select Member</h4>
            </div>
            <div class="modal-body">
                @Html.Action("GridGetSelectMemberPager", "Member", new { page = 1 })
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

@Html.Partial(MVC.Widget.Views.FileManager)

@section FooterScript{
    <link rel="stylesheet" href="@Links.Scripts.tagsinput.jquery_tagsinput_css" />
    <script src="@Links.Scripts.tagsinput.jquery_tagsinput_js"></script>
    <script>
        //var multipleSelectMember = MultipleSelectMember();

        //function MultipleSelectMember() {
        //    function init() {
        //        var multipleSelectMemberWrapper = $('<div class="multiple-select-member-wrapper"><div class="well multiple-select-member-value"></div></div>');
        //        var _element = $('.multiple-select-member'),
        //            _elementParent = _element.parent();

        //        _element.hide();
        //        $('.multiple-select-member').remove();
        //        multipleSelectMemberWrapper.append(_element);
        //        _elementParent.html('');
        //        _elementParent.append(multipleSelectMemberWrapper);
        //    }

        //    function getValues() {
        //        return $('.multiple-select-member').val().split(',')
        //    }

        //    function addValue(value) {
        //        var label = $('<span class="label label-default"> </span>');
        //        var labelContainer = $('.multiple-select-member-wrapper > .multiple-select-member-value');
        //        label.text(value);
        //        label.append('<span class="dismiss"> &times;</span>');
        //        labelContainer.append(label);
        //        var currentVal = getValues();
        //        currentVal.push(value);
        //        $('.multiple-select-member').val(currentVal.join(','))
        //    }

        //    return {
        //        init: init,
        //        getValues: getValues,
        //        addValue: addValue
        //    }
        //}

        $(document).ready(function () {
            $.extend($.validator.defaults, {
                invalidHandler: function (form, validator) {
                    var errors = validator.numberOfInvalids();
                    if (errors) {
                        var message = errors == 1
                        ? 'You missed 1 field. It has been highlighted.'
                        : 'You missed ' + errors + ' fields. They have been highlighted.';
                        noty({
                            text: message,
                            type: 'error',
                            timeout: 2000
                        });
                    }
                },
                errorPlacement: function (error, element) {
                    if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                        error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                    } else {
                        error.insertAfter(element)
                    }
                }
            });

            $('#MemberNames').tagsInput({
                defaultText: '',
                interactive: false,
                delimiter: ',',
                onAddTag: function () {

                },
                onRemoveTag: function (value) {
                    var selectedIDs = GetSelectedMemberIds(),
                        indexOfVal = selectedIDs.indexOf(value);
                    if (indexOfVal >= 0) {
                        selectedIDs.splice(indexOfVal, 1)
                        $('#MemberIDs').val(selectedIDs.join(','))
                    }
                },
            });

            $('#ToAllMembers').on('change', function () {
                if ($('#ToAllMembers').is(':checked')) {
                    $('#MemberNames').importTags('');
                    $('#MemberIDs').val('');
                    $('#btn-select-member').hide();
                    $('#btn-select-member').attr('disabled', 'disabled');
                } else {
                    $('#btn-select-member').show();
                    $('#btn-select-member').removeAttr('disabled');
                }
            })

            $("#Type").on('change', function () {
                if ($(this).val() === 'Custom') {
                    $('#DivLeftIcon, #DivRightIcon').removeClass('hidden');
                } else {
                    $('#DivLeftIcon, #DivRightIcon').addClass('hidden');
                }
            })

            function LoadGridFunctions() {
                function LoadData(dataUrl) {
                    if (dataUrl) {
                        $.ajax({
                            url: dataUrl,
                            complete: function (xhr, status) {
                                if (status === 'success') {
                                    $('div#memberModal .modal-body').html(xhr.responseText);
                                } else {
                                    alert(status + ' : ' + xhr.responseText);
                                }
                                LoadGridFunctions();
                            }
                        })
                    }
                }

                $('#grid-select-member div.grid-header-title > a, #grid-select-member .grid-footer ul.pagination li > a').on('click', function (e) {
                    e.preventDefault();
                    var dataUrl = $(this).data('url');
                    LoadData(dataUrl);
                })

                $('form[name=grid-select-member-form]').on('submit', function (e) {
                    e.preventDefault();
                    //e.stopPropagation();
                    HideLoader();
                    var dataUrl = decodeURIComponent($(this).find('[type=hidden][name=rawDataUrl]').val()).replace('@@search@@', $(this).find('[type=text][name=txtSearch]').val());
                    LoadData(dataUrl);
                })
            }

            $('#BtnLeftIcon').OpenFileManager('LeftIcon', 'image');
            $('#BtnRightIcon').OpenFileManager('RightIcon', 'image');
            LoadGridFunctions();
        });

        function GetSelectedMemberIds() {
            var valuesArr = $('#MemberIDs').val().split(',');
            if (valuesArr.length > 0 && valuesArr[0].toString().trim() === '') {
                valuesArr.splice(0, 1);
            }
            return valuesArr;
        }

        function SelectMember(MemberID, MemberName) {
            if (!$('#MemberNames').tagExist((MemberID).toString())) {
                $('#MemberNames').addTag(MemberID);
                var currentMemberIDs = GetSelectedMemberIds();
                currentMemberIDs.push(MemberID);
                $('#MemberIDs').val(currentMemberIDs.join(','))
            }
            $('#memberModal').modal('hide')
        };
    </script>
}